//--------------------------------------------------------------------------------------------
//Program Name : Main.c
//Description  : DONTSLEEP! C\[X
//--------------------------------------------------------------------------------------------
//History
//       1.     2007/02/03  Create
//       2.     2007/05/03  HDDANZXԊu0ȉA͖ݒ̏ꍇɖ\oOC
//                          ֐|C^̎gp@ύXi֐߂l|C^zj
//                          ̑A\[XR[hC
//       3.     2007/05/26  R\[AvP[VWindowsAvP[VɕύX
//                          JgfBNgʒuɊւ炸sł悤C
//       4.     2007/08/12  ANZXɃt@Cł͂ȂfBNg쐬悤C
//                          iANZX΍j
//       5.     2007/09/29  W֐삵ACRTNȂ悤C
//       6.     2007/11/01  gNہAnhYĂ̂C
//       7.     2013/09/21  64bitrhɑΉ
//                          INIt@CEXEt@CƓɂȂ悤ύX
//                          5.ō쐬W֐̂A\Ȃ̂Win32 APIɒuč폜
//       8.     2013/10/27  INIt@CǍs̋AvȌI牺LɕύX
//                          EANZXFǍ\ɂȂ܂őҋ@
//                          EANZXFOݒlœ
//       9.     2014/01/09  INIt@CǍ̏
//--------------------------------------------------------------------------------------------
//  All Rights Reserved, Copyright (c) XC 2014
//--------------------------------------------------------------------------------------------

#include<Windows.h>
#include"mycrt.h"

// t@CpXő咷
#define MAX_LENGTH_PATH (MAX_PATH-1)*2
// HDDANZXԊueŏlibj
#define HDD_ACCESS_INTERVAL_MIN 1
// HDDANZXԊulibj
#define HDD_ACCESS_INTERVAL_INIT HDD_ACCESS_INTERVAL_MIN
// őhCuihCuzvfj
#define DRIVE_NUM_MAX 26
// INIt@CǍpobt@TCY
#define BUFFER_SIZE 7
// HDDANZXpꎞfBNg
#define TMP_DIR_NAME "0:\\DNSLPTMP"

// bool^̒l
enum bool{
	false,
	true
};

// bool^
typedef int bool;

// INIt@Cf[^i[
typedef struct INIFileData{
	// HDDANZXԊu
	int nHDDAccessInterval;
	// hCuz
	char strDriveLetter[DRIVE_NUM_MAX];
	// hCuzCfbNX
	int nDriveLetterArrayIndex;
}INIFileData;

// R}hC̗L`FbN
bool ExistCommandLineArg();
// g}EXJ[\ύXȂŋN
void ExecuteOwnNonChangeCursor(char []);
// ݒt@CǍ
void ReadINIFile(const char [],INIFileData *);
	// HDDANZXԊuǍ
	void ReadHDDAccessInterval(const char [],INIFileData *,int *);
	// ANZXΏۃhCuǍ
	void ReadDriveLetter(const char [],INIFileData *,int *);
// HDDɃANZXiꎞfBNg쐬-폜j
void AccessHDD(const INIFileData *);

// C֐
void WinMainCRTStartup(){
	// INIt@Cf[^i[
	INIFileData stINIFileData;
	// EXEEINIt@CpX
	char strPath[MAX_LENGTH_PATH+4];
	strPath[0]='\"';

	// EXẼpX擾
	GetModuleFileName(NULL,&strPath[1],MAX_LENGTH_PATH);

	// R}hCw莞
	if(!ExistCommandLineArg()){
		// g}EXJ[\ύXȂŋN
		ExecuteOwnNonChangeCursor(strPath);
		ExitProcess(0);
	}

	// EXẼpXINIt@C̃pX쐬
	strcpy(strrchr(strPath,'.')+1,"INI");

	// HDDANZXԊuɏlݒ
	stINIFileData.nHDDAccessInterval=HDD_ACCESS_INTERVAL_INIT;
	// hCuzCfbNX
	stINIFileData.nDriveLetterArrayIndex=0;

	// ANZX[v
	while(1){
		// ݒt@CǍ
		ReadINIFile(&strPath[1],&stINIFileData);
		// HDDɃANZXiꎞfBNg쐬-폜j
		AccessHDD(&stINIFileData);
		// w莞ԕҋ@i~bj
		Sleep(stINIFileData.nHDDAccessInterval*1000);
	}
}

// R}hC̗L`FbN
bool ExistCommandLineArg(){
	// R}hC擾
	const char *pCommandLine=GetCommandLine();
	// R}hC̍Ōォ2Ԗڂ̕p󔒂̏ꍇA
	// Ƃ݂Ȃ
	return (*(pCommandLine+strlen(pCommandLine)-2)==' ' ? true : false);
}

// g}EXJ[\ύXȂŋN
void ExecuteOwnNonChangeCursor(char strEXEFilePath[]){
	// vZX
	PROCESS_INFORMATION stProcessInformation={0};
	// X^[gAbv
	STARTUPINFO stStartupInfo;
	mymemset(&stStartupInfo,0,sizeof(stStartupInfo));

	// }EXJ[\ύXȂ
	stStartupInfo.dwFlags=STARTF_FORCEOFFFEEDBACK;

	// gN
	CreateProcess(NULL,strcat(strEXEFilePath,"\" S"),NULL,NULL,FALSE,0,NULL,NULL,&stStartupInfo,&stProcessInformation);

	// XbhEvZXnh
	CloseHandle(stProcessInformation.hThread);
	CloseHandle(stProcessInformation.hProcess);
}

// ݒt@CǍ
void ReadINIFile(const char strINIFilePath[],INIFileData *pINIFileData){
	// t@CǍobt@
	char strBuffer[BUFFER_SIZE]={0};
	// t@C|C^
	HANDLE *pFilePointer=NULL;
	// ֐|C^zCfbNX
	int nFuncPointerArrayIndex=0;
	// ֐|C^z
	void (*pReadINIFileDataFunc[])(const char [],INIFileData *,int *)={
		// HDDANZXԊuǍ
		ReadHDDAccessInterval,
		// ANZXΏۃhCuǍ
		ReadDriveLetter
	};

	// INIt@CJ
	if((pFilePointer=CreateFile(strINIFilePath,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL))==INVALID_HANDLE_VALUE){
		// s
		return;
	}

	// hCuzCfbNX
	pINIFileData->nDriveLetterArrayIndex=0;

	// INIt@C1sǂݍ
	// [܂ōsAhCui[z񂪈tɂȂ܂Ń[v
	while(fgets(strBuffer,BUFFER_SIZE,pFilePointer) && pINIFileData->nDriveLetterArrayIndex<DRIVE_NUM_MAX){
		pReadINIFileDataFunc[nFuncPointerArrayIndex](strBuffer,pINIFileData,&nFuncPointerArrayIndex);
	}

	// INIt@C
	CloseHandle(pFilePointer);
	pFilePointer=NULL;
}

// HDDANZXԊuǍ
void ReadHDDAccessInterval(const char strBuffer[],INIFileData *pINIFileData,int *pFuncPointerArrayIndex){
	// ǂݍ񂾃f[^𐔒lϊ
	int nReadData=atoi(strBuffer);

	// lϊAeŏlȏ
	if(nReadData>=HDD_ACCESS_INTERVAL_MIN){
		// HDDANZXԊuɐݒ
		pINIFileData->nHDDAccessInterval=nReadData;
		// ̃f[^̓ǍɈڂ
		(*pFuncPointerArrayIndex)++;
	}
}

// ANZXΏۃhCuǍ
void ReadDriveLetter(const char strBuffer[],INIFileData *pINIFileData,int *pFuncPointerArrayIndex){
	// hCuKiA-Zj
	if(0x41<=strBuffer[0] && strBuffer[0]<=0x5a){
		// hCuzɊi[ACfbNXCNg
		pINIFileData->strDriveLetter[pINIFileData->nDriveLetterArrayIndex++]=strBuffer[0];
	}
}

// HDDɃANZXiꎞfBNg쐬-폜j
void AccessHDD(const INIFileData *pINIFileData){
	int i=0;
	// hCuzCfbNX
	int nDriveLetterArrayIndex=pINIFileData->nDriveLetterArrayIndex;
	// ꎞfBNgpX
	char strTempDirPath[]=TMP_DIR_NAME;

	// INIt@CǂݍHDD[v
	for(i=0;i<nDriveLetterArrayIndex;i++){
		// hCui[
		strTempDirPath[0]=pINIFileData->strDriveLetter[i];

		// ꎞfBNg쐬
		if(CreateDirectory(strTempDirPath,NULL) || GetLastError()==ERROR_ALREADY_EXISTS){
			// ꎞfBNg폜
			RemoveDirectory(strTempDirPath);
		}
	}
}
